/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   checker_port.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_CHECKER_PORT_H
#define UHDM_CHECKER_PORT_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/ports.h>




namespace UHDM {
class property_decl;
class sequence_decl;

class checker_port final : public ports {
  UHDM_IMPLEMENT_RTTI(checker_port, ports)
public:
  // Implicit constructor used to initialize all members,
  // comment: checker_port();
  virtual ~checker_port() final = default;

  VectorOfattribute* Attributes() const { return attributes_; }
  bool Attributes(VectorOfattribute* data) {
    attributes_ = data;
    return true;
  }

  property_decl* Property()  { return property_; }
  const property_decl* Property() const { return property_; }
  template <typename T>
  T* Property() {
    return (property_ == nullptr) ? nullptr : any_cast<T*>(property_);
  }
  template <typename T>
  const T* Property() const {
    return (property_ == nullptr) ? nullptr : any_cast<const T*>(property_);
  }
  bool Property(property_decl* data) {
    property_ = data;
    return true;
  }

  sequence_decl* Sequence()  { return sequence_; }
  const sequence_decl* Sequence() const { return sequence_; }
  template <typename T>
  T* Sequence() {
    return (sequence_ == nullptr) ? nullptr : any_cast<T*>(sequence_);
  }
  template <typename T>
  const T* Sequence() const {
    return (sequence_ == nullptr) ? nullptr : any_cast<const T*>(sequence_);
  }
  bool Sequence(sequence_decl* data) {
    sequence_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiCheckerPort; }

  virtual checker_port* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmchecker_port; }

protected:
  void DeepCopy(checker_port* clone, BaseClass* parent, CloneContext* context) const;

private:
  VectorOfattribute* attributes_ = nullptr;

  property_decl* property_ = nullptr;

  sequence_decl* sequence_ = nullptr;
};


typedef FactoryT<checker_port> checker_portFactory;


typedef FactoryT<std::vector<checker_port *>> VectorOfchecker_portFactory;

}  // namespace UHDM

#endif
