/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   hier_path.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_HIER_PATH_H
#define UHDM_HIER_PATH_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/simple_expr.h>

#include "actual_group.h"


namespace UHDM {


class hier_path final : public simple_expr {
  UHDM_IMPLEMENT_RTTI(hier_path, simple_expr)
public:
  // Implicit constructor used to initialize all members,
  // comment: hier_path();
  virtual ~hier_path() final = default;

  VectorOfany* Path_elems() const { return path_elems_; }
  bool Path_elems(VectorOfany* data) {
    if (!actual_groupGroupCompliant(data)) return false;
    path_elems_ = data;
    return true;
  }

  any* Root_value()  { return root_value_; }
  const any* Root_value() const { return root_value_; }
  template <typename T>
  T* Root_value() {
    return (root_value_ == nullptr) ? nullptr : any_cast<T*>(root_value_);
  }
  template <typename T>
  const T* Root_value() const {
    return (root_value_ == nullptr) ? nullptr : any_cast<const T*>(root_value_);
  }
  bool Root_value(any* data) {
    if (!actual_groupGroupCompliant(data)) return false;
    root_value_ = data;
    return true;
  }

  virtual bool VpiName(std::string_view data) final;
  virtual std::string_view VpiName() const final;

  bool VpiFullName(std::string_view data);
  std::string_view VpiFullName() const;

  virtual uint32_t VpiType() const final { return vpiHierPath; }

  virtual hier_path* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmhier_path; }

protected:
  void DeepCopy(hier_path* clone, BaseClass* parent, CloneContext* context) const;

private:
  VectorOfany* path_elems_ = nullptr;

  any* root_value_ = nullptr;

  SymbolId vpiName_;

  SymbolId vpiFullName_;
};


typedef FactoryT<hier_path> hier_pathFactory;


typedef FactoryT<std::vector<hier_path *>> VectorOfhier_pathFactory;

}  // namespace UHDM

#endif
