/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   method_func_call.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_METHOD_FUNC_CALL_H
#define UHDM_METHOD_FUNC_CALL_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/tf_call.h>

#include "expr_constr_group.h"


namespace UHDM {
class expr;
class function;

class method_func_call final : public tf_call {
  UHDM_IMPLEMENT_RTTI(method_func_call, tf_call)
public:
  // Implicit constructor used to initialize all members,
  // comment: method_func_call();
  virtual ~method_func_call() final = default;

  bool VpiUserDefn() const { return vpiUserDefn_; }
  bool VpiUserDefn(bool data) {
    vpiUserDefn_ = data;
    return true;
  }

  expr* Prefix()  { return prefix_; }
  const expr* Prefix() const { return prefix_; }
  template <typename T>
  T* Prefix() {
    return (prefix_ == nullptr) ? nullptr : any_cast<T*>(prefix_);
  }
  template <typename T>
  const T* Prefix() const {
    return (prefix_ == nullptr) ? nullptr : any_cast<const T*>(prefix_);
  }
  bool Prefix(expr* data) {
    prefix_ = data;
    return true;
  }

  any* With()  { return with_; }
  const any* With() const { return with_; }
  template <typename T>
  T* With() {
    return (with_ == nullptr) ? nullptr : any_cast<T*>(with_);
  }
  template <typename T>
  const T* With() const {
    return (with_ == nullptr) ? nullptr : any_cast<const T*>(with_);
  }
  bool With(any* data) {
    if (!expr_constr_groupGroupCompliant(data)) return false;
    with_ = data;
    return true;
  }

  function* Function()  { return function_; }
  const function* Function() const { return function_; }
  template <typename T>
  T* Function() {
    return (function_ == nullptr) ? nullptr : any_cast<T*>(function_);
  }
  template <typename T>
  const T* Function() const {
    return (function_ == nullptr) ? nullptr : any_cast<const T*>(function_);
  }
  bool Function(function* data) {
    function_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiMethodFuncCall; }

  virtual tf_call* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmmethod_func_call; }

protected:
  void DeepCopy(method_func_call* clone, BaseClass* parent, CloneContext* context) const;

private:
  bool vpiUserDefn_ = false;

  expr* prefix_ = nullptr;

  any* with_ = nullptr;

  function* function_ = nullptr;
};


typedef FactoryT<method_func_call> method_func_callFactory;


typedef FactoryT<std::vector<method_func_call *>> VectorOfmethod_func_callFactory;

}  // namespace UHDM

#endif
