/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   reg_array.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_REG_ARRAY_H
#define UHDM_REG_ARRAY_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>




namespace UHDM {
class expr;

class reg_array final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(reg_array, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: reg_array();
  virtual ~reg_array() final = default;

  bool VpiIsMemory() const { return vpiIsMemory_; }
  bool VpiIsMemory(bool data) {
    vpiIsMemory_ = data;
    return true;
  }

  expr* Left_expr()  { return left_expr_; }
  const expr* Left_expr() const { return left_expr_; }
  template <typename T>
  T* Left_expr() {
    return (left_expr_ == nullptr) ? nullptr : any_cast<T*>(left_expr_);
  }
  template <typename T>
  const T* Left_expr() const {
    return (left_expr_ == nullptr) ? nullptr : any_cast<const T*>(left_expr_);
  }
  bool Left_expr(expr* data) {
    left_expr_ = data;
    return true;
  }

  expr* Right_expr()  { return right_expr_; }
  const expr* Right_expr() const { return right_expr_; }
  template <typename T>
  T* Right_expr() {
    return (right_expr_ == nullptr) ? nullptr : any_cast<T*>(right_expr_);
  }
  template <typename T>
  const T* Right_expr() const {
    return (right_expr_ == nullptr) ? nullptr : any_cast<const T*>(right_expr_);
  }
  bool Right_expr(expr* data) {
    right_expr_ = data;
    return true;
  }

  VectorOfreg* Regs() const { return regs_; }
  bool Regs(VectorOfreg* data) {
    regs_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiRegArray; }

  virtual reg_array* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmreg_array; }

protected:
  void DeepCopy(reg_array* clone, BaseClass* parent, CloneContext* context) const;

private:
  bool vpiIsMemory_ = false;

  expr* left_expr_ = nullptr;

  expr* right_expr_ = nullptr;

  VectorOfreg* regs_ = nullptr;
};


typedef FactoryT<reg_array> reg_arrayFactory;


typedef FactoryT<std::vector<reg_array *>> VectorOfreg_arrayFactory;

}  // namespace UHDM

#endif
